/*
 * Copyright 2005-2009 WSO2, Inc. http://wso2.com
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
jQuery(document).ready(function() {

    renderLayout();     

    var settings = {};
    var portal;

    // Initialise the container
    gadgetserver.init();
    gadgetserver.renderGadgets();  

    $(".connect").sortable({
        connectWith: ['.connect'],
        opacity: 0.7,
        revert: true,
        scroll: true,
        delay: 250,
        placeholder: 'block-hover',
        tolerance: 'pointer',
        update: function(event, ui) {
            persistLayout();

        }
    });

    drawOptionsButton();
});

function drawOptionsButton() {
    var tabIds = UserPrefsService.getTabLayout(userId, dashboardName).split(',');
    var options = {minWidth: 120, arrowSrc: 'images/arrow_right.gif'};
    $('.opts').each(function() {
        //creating a menu without items
        var menu = new $.Menu('#' + $(this).attr('id'), null, options);

        //adding items to the menu
        menu.addItems([
            new $.MenuItem({src: 'Duplicate This Gadget', url: 'javascript:gadgets.container.getGadget(' + $(this).attr('id') + ').copyGadget()'}, options),
            new $.MenuItem({src: ''}), /* separator */
            new $.MenuItem({src: 'Settings', url: 'javascript:gadgets.container.getGadget(' + $(this).attr('id') + ').handleOpenUserPrefsDialog()'}, options),
            new $.MenuItem({src: ''}) /* separator */
        ]);
        var itemWithSubmenu = new $.MenuItem({src: 'Copy To', url: 'javascript:;'}, options);

        var itemArr = new Array();
        var count = 0;
        for (var i = 0; i < tabIds.length; i++) {
            var tabTitle = UserPrefsService.getTabTitle(userId, tabIds[i], dashboardName);
            if (currentActiveTab != tabIds[i]) {
                itemArr[count] = new $.MenuItem({src: tabTitle, url:'javascript:gadgets.container.getGadget(' + $(this).attr('id') + ').moveGadgetToTab(' + tabIds[i] + ')'}, options);
                count++;
            }
        }

        //creating a menu with items (as child of itemWithSubmenu)
        new $.Menu(itemWithSubmenu, itemArr, options);

        //adding the submenu to the main menu
        menu.addItem(itemWithSubmenu);

        menu.addItem(new $.MenuItem({src: 'About Gadget', url:'javascript:gadgets.container.getGadget(' + $(this).attr('id') + ').handleABoutGadget()'}, options));

    }
            )

}

/*function persistGadgetLayout() {
    var newLayout = $('#columns').sortable('toArray');

    // Stores the inferred gadget IDs from their DIV IDs
    var layoutGadgetIDs = new Array();
    var layoutGadgetIDs_index = 0;
    for (var x = 0; x < newLayout.length; x++) {
        var gadgetID = newLayout[x].split("-")[2];
        if ((gadgetID != undefined) && (!(gadgetID == ""))) {
            layoutGadgetIDs[layoutGadgetIDs_index] = gadgetID;
            layoutGadgetIDs_index++;
        }
    }

    // Calling the backend service via JS stub
    UserPrefsService.setGadgetLayout(userId, currentActiveTab, layoutGadgetIDs.toString(), dashboardName);
}

function persistGadgetLayoutProto() {

    var group1Pairs = $('#group1').sortable('serialize').split("&");
    var group2Pairs = $('#group2').sortable('serialize').split("&");
    var group3Pairs = $('#group3').sortable('serialize').split("&");

    var group1Ids = new Array();
    var gadgetLayoutIds = new Array();
    for (var i = 0; i < group1Pairs.length; i++) {
        group1Ids[i] = group1Pairs[i].split("=")[1];
        gadgetLayoutIds[i] = "G1#" + group1Pairs[i].split("=")[1];

    }
    if (group2Pairs != '') {
        var group2Ids = new Array();
        for (var i = 0; i < group2Pairs.length; i++) {
            group2Ids[i] = group2Pairs[i].split("=")[1];
            // if(i == 0){
            // gadgetLayoutIds[gadgetLayoutIds.length] = "&";
            // }
            gadgetLayoutIds[gadgetLayoutIds.length] = "G2#" +
                                                      group2Pairs[i].split("=")[1];
        }
    }
    if (group3Pairs != '') {
        var group3Ids = new Array();
        for (var i = 0; i < group3Pairs.length; i++) {
            group3Ids[i] = group3Pairs[i].split("=")[1];
            // if(i == 0){
            // gadgetLayoutIds[gadgetLayoutIds.length] = "&";
            // }
            gadgetLayoutIds[gadgetLayoutIds.length] = "G3#" +
                                                      group3Pairs[i].split("=")[1];
        }
    }

    // alert(gadgetLayoutIds.toString());
    UserPrefsService.setGadgetLayout(userId, currentActiveTab, gadgetLayoutIds.toString(), dashboardName);

    // alert(Sortable.serialize('group1')+Sortable.serialize('group2')+Sortable.serialize('group3'));
}*/

function clearMenuAndHeader() {
    // Removing the menu panel
    var menuPanel = document.getElementById("menu-panel");
    menuPanel.parentNode.removeChild(menuPanel);

    // Removing the header
    var headerElement = document.getElementById("header");
    headerElement.parentNode.removeChild(headerElement);

    // Fixing body height
    var bodyElement = document.getElementById("body")
    bodyElement.style.height = "500px";
}

function getFFVersion() {
    var versionData = navigator.userAgent || navigator.appVersion;
    var index = versionData.indexOf("Firefox");
    var ffVersion = 0;
    if (index == -1)
        ffVersion = 0;
    ffVersion = parseFloat(versionData.substring(index + "Firefox".length + 1));
    return ffVersion;
}
